#!/usr/bin/env python

#from mod_python import apache
from ofss import *
from cgi import escape,parse_qsl,parse_qs

import MySQLdb

def handler(req, xml): 
	if req.args:
		cgi = parse_qs(req.args, keep_blank_values = True, strict_parsing = True)
	else:
		cgi = None

	xml.data("<fss:request>hosts</fss:request>\n")
	xml.data("<fss:title>Fast SMB Search</fss:title>\n")
	xml.data("<fss:header/>\n")

	fssreq = FSSReq()
	fssreq.init_common(cgi)

	db = MySQLdb.connect("localhost", "fss", "fssPASS", "fss")
	if not db:
		raise FSSError("Unable to connect to sql")

	query = "WHERE (status = 'online')"
	curs = db.cursor()
	curs.execute("""SELECT comp_id FROM hosts %s LIMIT %d,%d""" % (query, fssreq.start, fssreq.end));
	db.close()

	xml.data("<fss:listnav url='hostlist.py?' start='%d' end='%d' step='100'/>\n" % (fssreq.start, fssreq.end))

	fss = FSS()
	xml.push("fss:filelist")
	xml.data("<fss:filemeta name='fss-link'/>\n")

	for row in curs.fetchall():
		fss.request("HOSTINFO %d" % row[0])
		line = fss.get_line()
		if (line == "ERROR"):
			raise FSSError("Server return error code on HOSTINFO request")
		fssreq.q_host(line)
		#xml.data("<fss:file id='%s' host='%s'/>" % (row[0], row[0]))
		if fssreq.status == "online":
			fss.request("""SEARCH 0 1 HOST_ID %s FILE_ID %s""" % (fssreq.host_id, fssreq.root_id))
			fssreq.q_query_id(fss.get_line())
			fssreq.q_count(fss.get_line())
			fssreq.q_file(fss.get_line(), xml)

	xml.pop("fss:filelist")
	xml.data("<fss:listnav url='hostlist.py?' start='%d' end='%d' step='100'/>\n" % (fssreq.start, fssreq.end))


